From 9395065e280e7826d10cd1cddbdb398f54ac3d6a Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Tue, 24 Aug 2010 18:20:57 +0200
Subject: [PATCH] Bring in arcmsr(4), a driver for Areca RAID controllers.

Taken-from: FreeBSD
---
 share/man/man4/Makefile      |    1 +
 share/man/man4/arcmsr.4      |  136 ++
 sys/conf/files               |    1 +
 sys/config/LINT              |    6 +
 sys/dev/raid/Makefile        |    2 +-
 sys/dev/raid/arcmsr/Makefile |   10 +
 sys/dev/raid/arcmsr/arcmsr.c | 3705 ++++++++++++++++++++++++++++
 sys/dev/raid/arcmsr/arcmsr.h | 5534 ++++++++++++++++++++++++++++++++++++++++++
 8 files changed, 9394 insertions(+), 1 deletions(-)
 create mode 100644 share/man/man4/arcmsr.4
 create mode 100644 sys/dev/raid/arcmsr/Makefile
 create mode 100644 sys/dev/raid/arcmsr/arcmsr.c
 create mode 100644 sys/dev/raid/arcmsr/arcmsr.h

diff --git a/share/man/man4/Makefile b/share/man/man4/Makefile
index f16c965..276386c 100644
--- a/share/man/man4/Makefile
+++ b/share/man/man4/Makefile
@@ -33,6 +33,7 @@ MAN=	aac.4 \
 	amr.4 \
 	an.4 \
 	aps.4 \
+	arcmsr.4 \
 	arp.4 \
 	ata.4 \
 	atapicam.4 \
diff --git a/sys/conf/files b/sys/conf/files
index e54a122..04c7120 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -126,6 +126,7 @@ dev/raid/aac/aac_disk.c			optional aac
 dev/raid/aac/aac_pci.c			optional aac pci
 dev/raid/aac/aac_linux.c		optional aac compat_linux
 dev/raid/aac/aac_cam.c			optional aacp aac
+dev/raid/arcmsr/arcmsr.c		optional arcmsr pci
 
 
 dev/pccard/pccbb/pccbb.c		optional cbb
diff --git a/sys/config/LINT b/sys/config/LINT
index 56bbd35..2149f0f 100644
--- a/sys/config/LINT
+++ b/sys/config/LINT
@@ -1252,6 +1252,12 @@ device		mlx		# Mylex DAC960
 device		amr		# AMI MegaRAID
 
 #
+# Areca 11xx and 12xx series of SATA II RAID controllers.
+# CAM is required.
+#
+device		arcmsr		# Areca SATA II RAID
+
+#
 # 3ware ATA RAID
 #
 device		twe		# 3ware ATA RAID
diff --git a/sys/dev/raid/Makefile b/sys/dev/raid/Makefile
index d5ef567..6d09813 100644
--- a/sys/dev/raid/Makefile
+++ b/sys/dev/raid/Makefile
@@ -1,6 +1,6 @@
 # $DragonFly: src/sys/dev/raid/Makefile,v 1.5 2004/04/16 20:13:16 drhodus Exp $
 #
 
-SUBDIR=aac amr asr ciss iir ips mlx mly pst twa twe vinum
+SUBDIR=aac amr arcmsr asr ciss iir ips mlx mly pst twa twe vinum
 
 .include <bsd.subdir.mk>
diff --git a/sys/dev/raid/arcmsr/Makefile b/sys/dev/raid/arcmsr/Makefile
new file mode 100644
index 0000000..b4090fb
--- /dev/null
+++ b/sys/dev/raid/arcmsr/Makefile
@@ -0,0 +1,10 @@
+# $FreeBSD: src/sys/modules/arcmsr/Makefile,v 1.1 2005/03/31 18:19:55 scottl Exp $
+
+.PATH: ${.CURDIR}/../../dev/arcmsr
+
+KMOD=	arcmsr
+SRCS=	arcmsr.c
+SRCS+=	opt_scsi.h opt_cam.h
+SRCS+=	device_if.h bus_if.h pci_if.h
+
+.include <bsd.kmod.mk>
